<%@ page
   session="true"
   import="javax.naming.*"
%>
<%
String WebCenterInstance="WebCenterInstance";
if (session.getAttribute("WebCenter_Instance")!=null)
    WebCenterInstance=session.getAttribute("WebCenter_Instance").toString();
else if (request.getContextPath()!=null)
  WebCenterInstance=request.getContextPath();
String ViewerApplet="Unsigned";
if (session.getAttribute("ViewerApplet")!=null)
	ViewerApplet=session.getAttribute("ViewerApplet").toString();
boolean signed=!ViewerApplet.equals("Unsigned");
boolean trusted=ViewerApplet.equals("SignedNotSandboxed");
%>
<%@ include file="logincheck.inc" %>
<%

response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
response.setHeader("Pragma","no-cache"); //HTTP 1.0
response.setDateHeader ("Expires", 0); //prevents caching at the proxy server


request.setCharacterEncoding("UTF-8");
//request.setCharacterEncoding("ISO-8859-1");
String returnUrl=request.getParameter("returnurl");
String close=request.getParameter("close");
if (close!=null && returnUrl!=null) {
  response.sendRedirect(returnUrl);
  return;
}
String compare=request.getParameter("compare");
if (compare==null)
  compare="0";
if (request.getParameter("signed")!=null)
  signed=request.getParameter("signed")=="1";
if (request.getParameter("trusted")!=null)
	trusted=request.getParameter("trusted")=="1";
String enc="utf-8";

String userAgent = request.getHeader("user-agent");
boolean isMacOS = userAgent!=null && userAgent.indexOf("Mac OS X")!=-1;
boolean isChrome = userAgent!=null && userAgent.indexOf("Chrome")!=-1;
boolean isSafari = userAgent!=null && userAgent.indexOf("Safari")!=-1 && userAgent.indexOf("Chrome")==-1;
boolean isFirefox = userAgent!=null && userAgent.indexOf("Firefox")!=-1;
boolean isIPad = userAgent!=null && userAgent.indexOf("iPad")!=-1;
boolean useJNLP = true;
boolean useSeparateJvm = false;

String destroySessionAfterCloseStr = (String)session.getAttribute("destroysessionafterclose");
session.setAttribute("destroysessionafterclose", null);	  // unset the value immediately
boolean destroySessionAfterClose = "1".equals(destroySessionAfterCloseStr);
%>
<html>
<head><title>WebCenter Viewer</title>
<meta http-equiv="Content-Style-Type" content="text/css">
<script language="JavaScript">

function cleanup() {
  document.viewer.destroy();
}

window.onbeforeunload = cleanup;  // called when somebody tries to get away from the page

</script>
</head>
<body style="background: #F7F7F7; margin-top: 3pt; margin-bottom: 0pt; margin-left: 0em; margin-right: 0em">
<%--
<table border="0" width="100%" height="100%">
<tr height="100%"><td>

--%>

<%
if (destroySessionAfterClose) {
%>
<script src="../javascript/webcenter_ajax.js" language="JavaScript"></script>
<script language="JavaScript">
function logoffOnServer()
{
	try {
		ajax({
			url: "../LogoffAndClose.jsp",
			type: "GET",
			data: "text",
			debug: false,
			synchronous: true,   // need to stall browser to not unload the page before the response is returned
			// timeout: 80000,
			onError: function(status) {window.alert("Unable to connect to WebCenter server")},
			onSuccess: function(xml) {}  
			//end: AJAX success callback					
		}) // End Ajax code
	} 
	catch (err) 
	{
		alert("Unable to connect to WebCenter server. Problem: " + err);
	}
}
window.onbeforeunload = logoffOnServer;
</script>
<%
}
%>

<!-- the script is used to workaround the KB912945 patch -->
<script src="write_control.js" language="JavaScript"></script>
<script language="JavaScript"> write_control( '\
<APPLET\
  NAME     = "viewer"\
  ARCHIVE  = "<%=(signed?(trusted?"SignedViewClientTrusted.jar":"SignedViewClient.jar"):"ViewClient.jar")%>"\
  CODE     = "com.eskographics.bitmapview.client.MainApplet.class"\
  WIDTH    = "100%"\
  HEIGHT   = "100%"\
  HSPACE   = "0"\
  VSPACE   = "0"\
  ALIGN    = "top"\
  ALT      = "(Your browser recognizes the APPLET element but does not run the applet.)"\
>\
')</script>
<%
	if(isIPad){
		String docVerId=null;
		if (session.getAttribute("PageXMLString")!=null){
			String pageList=session.getAttribute("PageXMLString").toString();
			if(pageList!=null)
				docVerId = pageList.substring(pageList.indexOf("<docversionid>") + "<docversionid>".length(), pageList.indexOf("</docversionid>"));
		}
%>
            
	<script language="JavaScript">
		function openDoc(){
			var wcurl = window.location.href.substring(0, window.location.href.indexOf('/view/')+1);
			wcurl += 'docdetailsgeninfo.jsp?docVerID=' + "<%=docVerId%>";
			
			var clickedAt =+ new Date;			

			// To avoid failing on return to MobileSafari, ensure freshness!            	
			setTimeout(function(){
				if (+new Date - clickedAt < 2000){
						window.location.href = "itms-apps://itunes.com/apps/webcenter";
					}
				}, 500);
			wcurl = wcurl.replace("http://", "webcenter://");
			wcurl = wcurl.replace("https://", "webcenter://");
			//	alert(wcurl);
			window.location.href = wcurl;
		}
	</script>
	<p><br/></p><p><br/></p>
	<table width="700px" cellpadding="0" cellspacing="0" border="0" align="center">
			<tbody>
				<tr>
					<td>
						<img src="./iPad/box_gray_topl.png" width="18"
							height="15" border="0"/>
					</td>
					<td>
						<img src="./iPad/box_gray_top.png" height="15"
							width="698" border="0"/>
					</td>
					<td align="left">
						<img src="./iPad/box_gray_topr.png" width="19"
							height="15" border="0"/>
					</td>
				</tr>
				<tr>
					<td background="./iPad/box_gray_l.png"></td>
					<td colspan="1" width="500px">
						<div class="itc-mobile">
							<img src="./iPad/WebCenter-icon.png"
								alt="WebCenter" width="43" height="49" style="float:left;margin-top:5px"/>
							<img src="./iPad/WebCenter.png" style="margin: 8px 0 0 10px;"
								alt="WebCenter"  />
							<p style="color: #4c4c4c;position: relative;left:12px;top: -5px;margin-bottom: 0;font:12px 'Lucida Grande';">Enjoy the viewing experience on your iPad. Launch the App to view this file.
									<img onClick="openDoc();" border="0" src="./iPad/button-launch.png" style="float: right;margin-right: 20px;margin-top:-3px;" alt="Launch" />
								
							</p>
						</div>
					</td>
					<td background="./iPad/box_gray_r.png"></td>
				</tr>
				<tr>
					<td>
						<img src="./iPad/box_gray_botl.png" width="18"
							height="15" alt="" border="0"/>
					</td>
					<td>
						<img src="./iPad/box_gray_bot.png" height="15"
							width="698" alt="" border="0"/>
					</td>
					<td align="left">
						<img src="./iPad/box_gray_botr.png" width="19"
							height="15" alt="" border="0"/>
					</td>
				</tr>
			</tbody>
		</table>
        <%
	} else{
		%>
<EM>Your browser either has no Java support at all or it has Java support disabled. To install/update Java go to <A HREF="http://java.com">Java.com</A>. To enable Java support, check your browser security settings or contact your IT administrator.</EM>
<%
	}
%>
<%-- 
<PARAM name="image" value="help_en/splash.jpg"/>
<PARAM name="boxmessage" value="Loading..."/>
<PARAM name="boxbgcolor" value="#f7f7f7"/>
<PARAM name="boxfgcolor" value="#777777"/>
<PARAM name="boxborder" value="false"/>
<PARAM name="centerimage" value="true"/>
--%>
<%
if (useJNLP) { // use JNLP
%>
<PARAM name="codebase_lookup" value="false"/>
<PARAM name="jnlp_href" value="<%=(signed?(trusted?"signed-unrestricted-viewer-applet.jnlp":"signed-viewer-applet.jnlp"):"viewer-applet.jnlp")%>"/>
<PARAM name="classloader_cache" value="false"/>
<%
} // end if
%>
<%
if (useSeparateJvm) { // use Separate JVM
%>
<PARAM name="java_arguments" value="-Xms256m -Xmx512m"/>
<PARAM name="separate_jvm" value="true"/>
<%
} // end if
%>
<PARAM name="sessionid" value="<%=URLEncoder.encode(session.getId(), enc)%>"/> 
<PARAM name="webappviewer" value="ViewServer"/> 
<PARAM name="webappwc" value="<%=URLEncoder.encode(WebCenterInstance, enc)%>"/> 
<PARAM name="compare" value="<%=compare%>"/>
<PARAM name="print" value="1"/>
<%--
<PARAM name="debug" value="1"/>
--%>
<PARAM name="querystring" value="<%=URLEncoder.encode(request.getRequestURL().toString(), enc)+"?"+
	URLEncoder.encode(request.getQueryString(), enc)%>"/> 
<%
/*
System.out.println("Query="+request.getQueryString());
System.out.println("DocName Parameter="+request.getParameter("docname"));
System.out.println("DocName Parameter enc="+URLEncoder.encode(request.getParameter("docname"), enc));
*/
String parameters[]={
    "docid", "docname", "docversionid", "docversion", "projectid", "projectname",
    "file", "diff", "cad", "style",
    "offsetx", "offsety", "orientation", "dalign", "dox", "doy",
    "margtop", "margbot", "margleft", "margright", "hsize", "vsize",
    "dmargtop", "dmargbot", "dmargleft", "dmargright", "dhsize", "dvsize",
    // deprecated elements that are still supported:
    "margin_top", "margin_bot", "margin_left", "margin_right",
    "margin_top_prev", "margin_bot_prev", "margin_left_prev", "margin_right_prev"
};
for (java.util.Enumeration enumeration=request.getParameterNames(); enumeration.hasMoreElements();) {
  String paramName = (String)enumeration.nextElement();
  boolean pageParam=false;
  for (int j=0; j<parameters.length; j++)
    if (paramName.equals(parameters[j])) {
      pageParam=true;
      break;
    }
  if (!pageParam) {
    String paramValues[]=request.getParameterValues(paramName);
    for (int i=0; i<paramValues.length; i++) {
      String paramValue=paramValues[i];
//      String paramValue=new String(paramValues[i].getBytes("ISO-8859-1"), "UTF-8");
%>
<PARAM name="<%=paramName%>" value="<%=URLEncoder.encode(paramValue, enc)%>"/>
<%
    }
  }
}
%>
<%
String pageList=null;
if (request.getParameter("docid")==null || request.getParameter("docid").length()==0)
  if (session.getAttribute("PageXMLString")!=null)
    pageList=session.getAttribute("PageXMLString").toString();

if (pageList==null || pageList.length()==0) {
  pageList="<pagelist><page>";
  for (int i=0; i<parameters.length; i++)
    if (request.getParameter(parameters[i])!=null)
      pageList+="<"+parameters[i]+">"+toXML(request.getParameter(parameters[i]))+"</"+parameters[i]+">";
//      pageList+="<"+parameters[i]+">"+toXML(new String(request.getParameter(parameters[i]).getBytes("ISO-8859-1"), "UTF-8"))+"</"+parameters[i]+">";
  pageList+="</page></pagelist>";
}
%>
<PARAM name="pagelist" value="<%=URLEncoder.encode(pageList, enc)%>"/> 

</APPLET>
<%--
</td></tr>
</table>
--%>
</body>
</html>
<%!
	public static String toXML(String t) {
		StringBuffer b=new StringBuffer(t);
		int whitespace=0;
		for (int i=b.length()-1; i>=0; i--) {
			char ch=b.charAt(i);
			switch (ch) {
				case '&':
					b.replace(i, i+1, "&amp;");
					break;
				case '<':
					b.replace(i, i+1, "&lt;");
					break;
				case '>':
					b.replace(i, i+1, "&gt;");
					break;
				case '"':
					b.replace(i, i+1, "&quot;");
					break;
				default:
					if (ch>127) {
						//String hex = new String("&#x" + Integer.toHexString(ch) + ";");
						String hex = new String("&#" + (int)ch + ";");
						b.replace(i, i+1, hex);
					}
					break;
			}
		}
		return b.toString();
	}  
%>